//+------------------------------------------------------------------+
//|                                          !trade4me_functions.mq4 |
//|                                                         Trade4me |
//|                                                 http://trade4.me |
//+------------------------------------------------------------------+
#property copyright "Trade4me"
#property link      "http://trade4.me"

//+------------------------------------------------------------------+
//| DLL imports for server comunications                             |
//+------------------------------------------------------------------+
//Make sure you allowed DLL imports in your Metatrader preferences.
#define READURL_BUFFER_SIZE   1000

#import "wininet.dll"
   int InternetOpenW(string, int, string, string, int);
   int InternetOpenUrlW(int, string, string, int, int, int);
   int InternetCloseHandle(int);
   int InternetReadFile(int, uchar & arr[], int, int & arr[]);
#import

//+------------------------------------------------------------------+
//| Function imports                                                      |
//+------------------------------------------------------------------+
void trade4me(string asset, string direction, int expiry){
  
      if(direction=="UP"){
         //display("CALL (UP)       ",Blue);
         Alert("UP "+asset+" signal sent to Trade4.me servers");
         //if (SendPhoneNotifications) SendNotification("CALL "+asset+" Signal sent to Trade4.me");
         //if (SendEmails) SendMail("CALL "+asset+" Signal sent to Trade4.me","CALL "+asset+" Signal sent to Trade4.me");
         //Call[0]=Low[0]-0.0001;
      }
      
      if(direction=="DOWN"){
         //display("PUT (DOWN)      ",Red);
         Alert("DOWN "+asset+" signal sent to Trade4.me");
         //if (SendPhoneNotifications) SendNotification("PUT "+asset+" Signal sent to Trade4.me");
         //if (SendEmails) SendMail("PUT "+asset+" Signal sent to Trade4.me","PUT "+asset+" Signal sent to Trade4.me");
         //Put[0]=High[0]+0.0001;
      }
   
      // Open Keys
      int Handle;                  
      string pubkey, subkey, channel;
          
//-----------------------------------------------------------------
   Handle=FileOpen("pubkey.txt",FILE_READ);// File opening
   if(Handle<0)                        // File opening fails
     {
      if(GetLastError()==4103)         // If the file does not exist,..
         Alert("No file named ","pubkey.txt");//.. inform trader
      else                             // If any other error occurs..
         Alert("Error while opening file ","pubkey.txt");//..this message
      PlaySound("Bzrrr.wav");          // Sound accompaniment
      return;                          // Exit start()      
     }
   while(FileIsEnding(Handle)==false)  // While the file pointer..
     {                                 // ..is not at the end of the file
      pubkey =FileReadString(Handle);// Date and time of the event (date)
      if(FileIsEnding(Handle)==true)   // File pointer is at the end
         break;                        // Exit reading and drawing
     }
   FileClose( Handle );                // Close file
 //-----------------------------------------------------------------
   Handle=FileOpen("subkey.txt",FILE_READ);// File opening
   if(Handle<0)                        // File opening fails
     {
      if(GetLastError()==4103)         // If the file does not exist,..
         Alert("No file named ","subkey.txt");//.. inform trader
      else                             // If any other error occurs..
         Alert("Error while opening file ","subkey.txt");//..this message
      PlaySound("Bzrrr.wav");          // Sound accompaniment
      return;                          // Exit start()      
     }
   while(FileIsEnding(Handle)==false)  // While the file pointer..
     {                                 // ..is not at the end of the file
      subkey =FileReadString(Handle);// Date and time of the event (date)
      if(FileIsEnding(Handle)==true)   // File pointer is at the end
         break;                        // Exit reading and drawing
     }
   FileClose( Handle );                // Close file
 //-----------------------------------------------------------------
   Handle=FileOpen("channel.txt",FILE_READ);// File opening
   if(Handle<0)                        // File opening fails
     {
      if(GetLastError()==4103)         // If the file does not exist,..
         Alert("No file named ","channel.txt");//.. inform trader
      else                             // If any other error occurs..
         Alert("Error while opening file ","channel.txt");//..this message
      PlaySound("Bzrrr.wav");          // Sound accompaniment
      return;                          // Exit start()      
     }
   while(FileIsEnding(Handle)==false)  // While the file pointer..
     {                                 // ..is not at the end of the file
      channel =FileReadString(Handle);// Date and time of the event (date)
      if(FileIsEnding(Handle)==true)   // File pointer is at the end
         break;                        // Exit reading and drawing
     }
   FileClose( Handle );                // Close file
 //-----------------------------------------------------------------
   
   //Alert(pubkey);
   //Alert(subkey);
   //Alert(channel);
   
     if(!TerminalInfoInteger(TERMINAL_DLLS_ALLOWED))
     {
      Alert("-DLL is not allowed");
     }
   
      // HTTP Request
      //int HttpOpen = InternetOpenW("HTTP_Client_Sample", 0, "", "", 0); 
      //int HttpConnect = InternetConnectW(HttpOpen, "", 80, "", "", 3, 0, 1); 
      //int HttpRequest = InternetOpenUrlW(HttpOpen, "http://trade4.me/signal.php?pubkey="+pubkey+"&subkey="+subkey+"&channel="+channel+"&direction="+direction+"&asset="+asset+"&expiry="+expiry, NULL, 0, 0, 0);
   
     string strData = ReadUrl("http://trade4.me/signal.php?pubkey="+pubkey+"&subkey="+subkey+"&channel="+channel+"&direction="+direction+"&asset="+asset+"&expiry="+expiry, true);
               
     Alert("Trade4.me servers response : ", strData);
            
return;
}

// Reads the specified URL and returns the server's response. Return value is 
// a blank string if an error occurs                
string ReadUrl(string Url, bool PrintDebuggingMessages = false)
{
   string strData = "";
   bool bSuccess = false;
   
   // Get an internet handle
   int hInternet = InternetOpenW("mt4", 0 /* 0 = INTERNET_OPEN_TYPE_PRECONFIG */, NULL, NULL, 0);
   if (hInternet == 0) {
      if (PrintDebuggingMessages) Print("InternetOpenW() failed");

   } else {
      // Get a URL handle
      int hInternetUrl = InternetOpenUrlW(hInternet, Url, NULL, 0, 0, 0);
      if (hInternetUrl == 0) {
         if (PrintDebuggingMessages) Print("InternetOpenUrlW() failed");

      } else {
         if (PrintDebuggingMessages) Print("Okay: url handle: ", hInternetUrl);

         // We potentially (in fact, usually) get the response in multiple chunks
         // Keep calling InternetReadFile() until it fails, or until
         // it says that the read is complete
         bool bKeepReading = true;
         while (bKeepReading) {                    
            int szRead[1];
            uchar arrReceive[];
            ArrayResize(arrReceive, READURL_BUFFER_SIZE + 1);
            int success = InternetReadFile(hInternetUrl, arrReceive, READURL_BUFFER_SIZE, szRead);

            if (success == 0) {
               if (PrintDebuggingMessages) Print("InternetReadFile() failed");
               bKeepReading = false;

            } else {
               // InternetReadFile() has succeeded, but we may be at the end of the data 
               if (szRead[0] == 0) {
                  if (PrintDebuggingMessages) Print("Reached end of data");
                  bKeepReading = false;
                  bSuccess = true;
                  
               } else {
                  // Convert the data from Ansi to Unicode using the built-in MT4 function
                  string strThisRead = CharArrayToString(arrReceive, 0, szRead[0], CP_UTF8);
                  strData = StringConcatenate(strData, strThisRead);  // <-- PROBLEM HERE ON FIRST USE ONLY IN EACH MT4 SESSION
               }
            }
         }
         InternetCloseHandle(hInternetUrl);
      }
      InternetCloseHandle(hInternet);
   }

   return (strData);
}